Attribute VB_Name = "MODUL_SCRATCHPAD"
Option Explicit

Public Function MESSEN_ALLE() As Byte
' RESET-PRESENCE + SKIP ROM + CONVERT T  senden         '
' OUT: 0=ERROR 1=OK                                     '
Dim DUMMY As Byte

DUMMY = ROM_SKIP()
If DUMMY <> 1 Then
    Exit Function
End If
' CONVERT T
DUMMY = PAKET_SENDEN(Asc("W"), &H44)

WAIT_1s

MESSEN_ALLE = 1

End Function


Public Function MESSEN_EINZELN(ROM_ID As String) As Byte
Dim DUMMY As Byte

DUMMY = ROM_MATCH(ROM_ID)

' CONVERT T
DUMMY = PAKET_SENDEN(Asc("W"), &H44)

WAIT_1s

MESSEN_EINZELN = 1

End Function


Public Function SINGLE_SCRATCHPAD_9_READ()
Dim DUMMY As Byte
Dim i As Integer
' clear
For i = 0 To 1000
    FELD_1WIRE_SCRATCHPAD_STRING(i) = ""
Next i

' RESET-PRESENCE
DUMMY = RESET_PRESENCE()
If DUMMY <> 1 Then
    SINGLE_SCRATCHPAD_9_READ = "000000000000000000"
    Exit Function
End If


' BYTE senden
DUMMY = PAKET_SENDEN(Asc("W"), &HCC)
' FUNCTION-COMMAND senden(SCRATCHPAD-READ)
DUMMY = PAKET_SENDEN(Asc("W"), &HBE)
'BYTES0
DUMMY = PAKET_SENDEN(Asc("R"), 0)
SINGLE_SCRATCHPAD_9_READ = DEZ_HEX8(DUMMY) & SINGLE_SCRATCHPAD_9_READ
'BYTES1
DUMMY = PAKET_SENDEN(Asc("R"), 0)
SINGLE_SCRATCHPAD_9_READ = DEZ_HEX8(DUMMY) & SINGLE_SCRATCHPAD_9_READ
'BYTES2
DUMMY = PAKET_SENDEN(Asc("R"), 0)
SINGLE_SCRATCHPAD_9_READ = DEZ_HEX8(DUMMY) & SINGLE_SCRATCHPAD_9_READ
'BYTES3
DUMMY = PAKET_SENDEN(Asc("R"), 0)
SINGLE_SCRATCHPAD_9_READ = DEZ_HEX8(DUMMY) & SINGLE_SCRATCHPAD_9_READ
'BYTES4
DUMMY = PAKET_SENDEN(Asc("R"), 0)
SINGLE_SCRATCHPAD_9_READ = DEZ_HEX8(DUMMY) & SINGLE_SCRATCHPAD_9_READ
'BYTES5
DUMMY = PAKET_SENDEN(Asc("R"), 0)
SINGLE_SCRATCHPAD_9_READ = DEZ_HEX8(DUMMY) & SINGLE_SCRATCHPAD_9_READ
'BYTES6
DUMMY = PAKET_SENDEN(Asc("R"), 0)
SINGLE_SCRATCHPAD_9_READ = DEZ_HEX8(DUMMY) & SINGLE_SCRATCHPAD_9_READ
'BYTES7
DUMMY = PAKET_SENDEN(Asc("R"), 0)
SINGLE_SCRATCHPAD_9_READ = DEZ_HEX8(DUMMY) & SINGLE_SCRATCHPAD_9_READ
'BYTES8
DUMMY = PAKET_SENDEN(Asc("R"), 0)
SINGLE_SCRATCHPAD_9_READ = DEZ_HEX8(DUMMY) & SINGLE_SCRATCHPAD_9_READ

FELD_1WIRE_SCRATCHPAD_STRING(0) = SINGLE_SCRATCHPAD_9_READ


End Function

Public Function SCRATCHPAD_9_READ(ROM_ID As String) As String
Dim FAM As String
Dim DUMMY As Byte
Dim SEND_BYTE As Byte
' FAMILY-CODE
FAM = Mid(ROM_ID, 15, 2)
If FAM = "10" Then GoTo START
If FAM = "22" Then GoTo START
If FAM = "28" Then GoTo START
Exit Function

START:


'ROM-MATCH
DUMMY = ROM_MATCH(ROM_ID)
If DUMMY <> 1 Then
    SCRATCHPAD_9_READ = "000000000000000000"
    Exit Function
End If

' READ SCRATCHPAD
DUMMY = PAKET_SENDEN(Asc("W"), &HBE)
' 9 BYTES einlesen
SCRATCHPAD_9_READ = DEZ_HEX8(PAKET_SENDEN(Asc("R"), 0))
SCRATCHPAD_9_READ = DEZ_HEX8(PAKET_SENDEN(Asc("R"), 0)) & SCRATCHPAD_9_READ
SCRATCHPAD_9_READ = DEZ_HEX8(PAKET_SENDEN(Asc("R"), 0)) & SCRATCHPAD_9_READ
SCRATCHPAD_9_READ = DEZ_HEX8(PAKET_SENDEN(Asc("R"), 0)) & SCRATCHPAD_9_READ
SCRATCHPAD_9_READ = DEZ_HEX8(PAKET_SENDEN(Asc("R"), 0)) & SCRATCHPAD_9_READ
SCRATCHPAD_9_READ = DEZ_HEX8(PAKET_SENDEN(Asc("R"), 0)) & SCRATCHPAD_9_READ
SCRATCHPAD_9_READ = DEZ_HEX8(PAKET_SENDEN(Asc("R"), 0)) & SCRATCHPAD_9_READ
SCRATCHPAD_9_READ = DEZ_HEX8(PAKET_SENDEN(Asc("R"), 0)) & SCRATCHPAD_9_READ
SCRATCHPAD_9_READ = DEZ_HEX8(PAKET_SENDEN(Asc("R"), 0)) & SCRATCHPAD_9_READ




End Function

Public Function BERECHNUNG_SCRATCHPAD_WERT(ROM_ID As String, SCRATCHPAD As String) As String
Dim FAM As String

Dim TEMPERATUR_READ As Byte
Dim COUNT_PER_C As Byte
Dim COUNT_REMAIN As Byte

If SCRATCHPAD = "000000000000000000" Then
    BERECHNUNG_SCRATCHPAD_WERT = "?"
    Exit Function
End If
If SCRATCHPAD = "FFFFFFFFFFFFFFFFFF" Then
    BERECHNUNG_SCRATCHPAD_WERT = "?"
    Exit Function
End If
' Auswahl FAMILY
FAM = Mid(ROM_ID, 15, 2)
If FAM = "10" Then GoTo BERECHNUNG_x10
If FAM = "22" Then GoTo BERECHNUNG_x22
If FAM = "28" Then GoTo BERECHNUNG_x28
BERECHNUNG_SCRATCHPAD_WERT = "?????"
Exit Function

'----------------------------------------------------------------------------------------------------------
BERECHNUNG_x10:

TEMPERATUR_READ = HEX8_DEZ(Mid(SCRATCHPAD, 17, 2))
COUNT_PER_C = HEX8_DEZ(Mid(SCRATCHPAD, 3, 2))
COUNT_REMAIN = HEX8_DEZ(Mid(SCRATCHPAD, 5, 2))

BERECHNUNG_SCRATCHPAD_WERT = Format(TEMPERATUR_READ * 0.5 - 0.25 + (COUNT_PER_C - COUNT_REMAIN) / COUNT_PER_C, "#.00") & " C"
Exit Function
'----------------------------------------------------------------------------------------------------------
BERECHNUNG_x22:

BERECHNUNG_SCRATCHPAD_WERT = Format(HEX16_DEZ(Mid(SCRATCHPAD, 15, 4)) / 16, "#.00") & " C"

Exit Function
'----------------------------------------------------------------------------------------------------------
BERECHNUNG_x28:

GoTo BERECHNUNG_x22

Exit Function
'----------------------------------------------------------------------------------------------------------









End Function
